//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Library General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef CITYLIST_H
#define CITYLIST_H

#include "ObjectList.h"
#include <paragui.h>
#include <sigc++/object_slot.h>

class City;
class Player;

class Citylist : public ObjectList<City>, public SigC::Object
{
	public:
        static Citylist* getInstance();
        static Citylist* getInstance(XML_Helper* helper);
        static void deleteInstance();

		// MANIPULATORS
        void nextTurn(Player* p);
		bool save(XML_Helper* helper);
		
		// ACCESSORS
		int countCities(Player* p) const;
		bool load(std::string tag, XML_Helper* helper);
		City* getNearestEnemyCity(const PG_Point& pos);
        City* getFirstCity(Player* p);

    protected:
		// CREATORS
		Citylist();
		Citylist(XML_Helper* helper);
		~Citylist();

    private:
        static Citylist* s_instance;
};

#endif // CITYLIST_H

// End of file
