//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Library General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef SPLASH_H
#define SPLASH_H

#include <pgthemewidget.h>
#include <pgeventobject.h>
#include "GameScenario.h"

class PG_Button;
class PG_Application;
class MainWindow;

class Splash : public PG_EventObject, public PG_ThemeWidget,
                public SigC::Object
{
	public:
		// CREATORS
		Splash(PG_Application* app, const PG_Rect& rect);
		~Splash();
		
		// MANIPULATORS
		void newGame(GameScenario::GameType gameType, std::string ip = "", int port = 0);

		// CALLBACK FUNCTIONS
		PARAGUI_CALLBACK(b_quitClicked);
		PARAGUI_CALLBACK(b_campaignClicked);
		PARAGUI_CALLBACK(b_singleplayerGameClicked);
		PARAGUI_CALLBACK(b_multiplayerGameClicked);
		PARAGUI_CALLBACK(b_loadGameClicked);

        void gameFinished();

	private:
		void clearData();
		
		// DATA
		MainWindow* d_mainWindow;

		// WIDGETS
		PG_Application* d_app;
		PG_Button* d_b_campaign;
		PG_Button* d_b_singleplayer_game;
		PG_Button* d_b_multiplayer_game;
		PG_Button* d_b_load_game;
		PG_Button* d_b_quit;
        SDL_Surface* d_background;
};

#endif // SPLASH_H

// End of file
